import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { map } from 'rxjs';
import { apiTemp } from '../../environments/environment.prod';

@Injectable({
  providedIn: 'root'
})
export class DocumentManagementService {

  constructor(private _http: HttpClient) {}

  getFileInfo(id: string, idUser: string, line: number) {
    return this.getQuery(`get-file-info/${id}/${idUser}/${line}`).pipe(
      map((data: any) => data)
    );
  }

  deleteTempFile(body: any) {
    return this.postQuery('delete-file', body).pipe(map((data: any) => data));
  }

  getDownloadToken(idFile: string, idUser: string, line: number){
    return this.getQuery(`get-download-token/${idFile}/${idUser}/${line}`).pipe(map((data: any) => data))
  }

  checkIfExist(url: string) {
    return this.getQuery(`${url}`).pipe(map((data: any) => data))
  }

  getQuery(query: string) {
    const JWT = `Bearer ${localStorage.getItem('token')}`;
    const URL = `${apiTemp}${query}`;
    return this._http.get(URL, {
      headers: new HttpHeaders({
        Authorization: JWT,
      }),
    });
  }

  postQuery(query: string, body: any) {
    const JWT = `Bearer ${localStorage.getItem('token')}`;
    const URL = `${apiTemp}${query}`;
    return this._http.post(URL, body, {
      headers: new HttpHeaders({
        Authorization: JWT!,
      }),
    });
  }
}
